#define WIN32_LEAN_AND_MEAN
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

#ifdef _WIN32
#include <windows.h>
#include <winbase.h>
#define APPNAME "CUT32"
#if defined(_DLL) && defined(_M_IX86)
#pragma comment(lib, "minwcrt.lib")
#endif
#else
#define APPNAME "CUT"
#endif

void  help( void );

// Den hr buffertlngden skulle egentligen kunna vara
// mycket strre fr 32-bitarsversionen.
#define BUFLEN ((size_t)32767)

int
main( int argc, char *argv[] )
{
  int   margin,
    offset=0;
  char	*buf;
  unsigned  lines=0;

  if( argc - 1 )
    {
      if( (argv[1][0] | 2) == '/' )
	{
	  help();
	  return 0;
	}
      if( argc - 2 )
	offset = atoi( argv[2] );

      margin = atoi( argv[1] );

      if( margin + offset >= BUFLEN - 1 )
	{
	  puts( "Fr stort parametervrde." );
	  return 0;
	}
    }
  else
    {
      help();
      return 0;
    }

  if( (buf = (char*)malloc( BUFLEN )) == NULL )
    {
      fputs( "Otillrckligt minne.", stderr );
      return 0;
    }

  for (;;)
    {
      buf[margin] = 0;

      if( fgets( buf, BUFLEN - 1, stdin ) == NULL )
	return lines;

      buf[BUFLEN - 2] = '\n';
      buf[BUFLEN - 1] = 0;

      if( offset && buf[margin + offset] )
	{
	  buf[margin + offset] = '\n';
	  buf[margin + offset + 1] = 0;
	}

      if( fputs( buf + margin, stdout ) == EOF )
	return lines;

      ++ lines;
#ifdef __WIN32__
      Sleep(0);	// Thread pause s att andra processer kan kra
#endif
    }
}

void help( void )
{
  puts(
       APPNAME
       ".EXE - Freeware av Olof Lagerkvist 1998.\r\n"
       "http://www.ltr-data.se      olof@ltr-data.se\r\n"
       "Ls "
       APPNAME
       ".TXT fr information om distribution m m.\r\n"
       "\n"
       "Det hr programmet kopierar frn STDIN till STDOUT men klipper bort texten\r\n"
       "till vnster om en viss position. Offset anger maximal radlngd.\r\n"
       "\n"
       APPNAME
       " marginal [offset]\r\n"
       "\n"
       "Programmet returnerar antal behandlade rader."
       );
}
