#define WIN32_LEAN_AND_MEAN
#include <winstrct.h>

#if defined(_DLL) && defined(_M_IX86)
#pragma comment(lib, "minwcrt.lib")
#endif

int
main(int argc, char **argv)
{
    STARTUPINFO sif = { sizeof(sif) };
    PROCESS_INFORMATION pif;
    BOOL uniproc = FALSE;
    BOOL suspended = FALSE;

    argc;

    if (argv[1] == NULL)
    {
        puts("Creates a process and returns process id.\r\n"
            "Syntax:\r\n"
            "\n"
            "cpretpid [/u] [/s] commandline\r\n"
            "\n"
            "/u    Run on first processor only.\r\n"
            "/s    Create suspended.");
        return 0;
    }

    for (;;)
    {
        if (_strcmpi(argv[1], "/U") == 0)
        {
            argv++;
            uniproc = TRUE;
        }
        else if (_strcmpi(argv[1], "/S") == 0)
        {
            argv++;
            suspended = TRUE;
        }
        else
        {
            break;
        }
    }

    if (!CreateProcess(NULL, strstr(GetCommandLine(), argv[1]), NULL, NULL,
        FALSE, CREATE_NEW_CONSOLE | CREATE_NEW_PROCESS_GROUP |
        CREATE_SUSPENDED | GetPriorityClass(GetCurrentProcess()),
        NULL, NULL, &sif, &pif))
    {
        win_perror("Error creating process");
        return 0;
    }

    if (uniproc &&
        SetProcessAffinityMask(pif.hProcess, 1))
    {
        win_perror("Error setting affinity mask for new process");
    }

    if (!suspended)
    {
        if (!ResumeThread(pif.hThread))
        {
            win_perror("Error resuming thread");
        }
    }

    return pif.dwProcessId;
}
