#define UNICODE
#define _UNICODE
#ifndef _DLL
#define _DLL
#endif
#define WIN32_LEAN_AND_MEAN
#include <minwcrtlib.h>
#include <winstrct.h>
#include <shellapi.h>
#include <ntdll.h>

#pragma comment(lib, "kernel32.lib")
#pragma comment(lib, "shell32.lib")
#ifdef _M_IX86
#pragma comment(lib, "crtdll.lib")
#endif
#pragma comment(lib, "ntdll.lib")

int
wmain(int argc, LPWSTR *argv)
{
  int argcc = argc;

  SetOemPrintFLineLength(GetStdHandle(STD_ERROR_HANDLE));

  while (--argcc)
    {
      UNICODE_STRING NtName;
      ++argv;
      
      if (!RtlDosPathNameToNtPathName_U(argv[0], &NtName, NULL, NULL))
	oem_printf(stderr, "Invalid path: '%1!ws!'%%n", argv[0]);
      else
	{
	  if (argc > 2)
	    oem_printf(stdout,
		       "%1!ws! -> %2!wZ!%%n",
		       argv[0],
		       &NtName);
	  else
	    oem_printf(stdout,
		       "%1!wZ!%%n",
		       &NtName);

	  RtlFreeUnicodeString(&NtName);
	}
    }
}

// This is enough startup code for this program if compiled to use the DLL CRT.
#if !defined(_DEBUG) && !defined(DEBUG) && _MSC_VER < 1900
EXTERN_C int
wmainCRTStartup()
{
    int argc = 0;
    LPWSTR *argv = CommandLineToArgvW(GetCommandLine(), &argc);
    if (argv == NULL)
    {
#ifndef _M_ARM
        MessageBoxA(NULL, "This program requires Windows NT.",
            "Incompatible Windows version", MB_ICONERROR);
#endif
        ExitProcess((UINT)-1);
    }

    exit(wmain(argc, argv));
}
#endif
