#ifndef UNICODE
#define UNICODE
#endif
#ifndef _UNICODE
#define _UNICODE
#endif
#ifndef _DLL
#define _DLL
#endif
#ifndef _CRT_NON_CONFORMING_WCSTOK
#define _CRT_NON_CONFORMING_WCSTOK
#endif
#ifndef WIN32_LEAN_AND_MEAN
#define WIN32_LEAN_AND_MEAN
#endif

#include <stdio.h>
#include <minwcrtlib.h>

#include <winstrct.h>
#include <wio.h>
#include <lm.h>
#include <shellapi.h>

#pragma comment(lib, "kernel32.lib")
#pragma comment(lib, "shell32.lib")
#pragma comment(lib, "netapi32.lib")

int
wmain(int iArgc, LPWSTR *lpwArgv)
{
    DWORD dwErrRet;
    LPCWSTR wczAccountOU;
    LPCWSTR wczComputerName;
    LPCWSTR wczUserName = NULL;
    LPCWSTR wczPassword = NULL;

    SetOemPrintFLineLength(GetStdHandle(STD_ERROR_HANDLE));

    if ((iArgc < 3) | (iArgc > 5))
    {
        fputs("Syntax:\r\n"
            "joindomain [compaccountou\\]computer domain[\\dc] [admaccount [admpassword]]\r\n",
            stderr);
        return 1;
    }

    wczAccountOU = wcstok(lpwArgv[1], L"\\");
    wczComputerName = wcstok(NULL, L"");
    if (wczComputerName == NULL)
    {
        wczComputerName = wczAccountOU;
        wczAccountOU = NULL;
    }

    if (iArgc > 3)
    {
        wczUserName = lpwArgv[3];
    }

    if (iArgc > 4)
    {
        wczPassword = lpwArgv[4];
    }

    if (wczPassword != NULL &&
        wczPassword[0] == '*' && wczPassword[1] == 0)
    {
        char cPassword[MAX_PATH];
        HANDLE hIn = GetStdHandle(STD_INPUT_HANDLE);

        printf("Password: ");
        ReadPassword(hIn, cPassword, sizeof cPassword);
        puts("");

        wczPassword = ByteToWideAlloc(cPassword);
    }

    dwErrRet = NetJoinDomain(wczComputerName, lpwArgv[2], wczAccountOU,
        wczUserName,
        wczPassword,
        NETSETUP_JOIN_DOMAIN |
        NETSETUP_ACCT_CREATE |
        NETSETUP_DOMAIN_JOIN_IF_JOINED);

    if (dwErrRet == NERR_Success)
    {
        oem_printf
            (stdout,
                "The computer '%1!ws!' was successfully joined to '%2!ws!'.%%n",
                wczComputerName, lpwArgv[2]);
        return 0;
    }
    else
    {
        LPSTR errmsg = win_errmsgA(dwErrRet);
        oem_printf(stderr,
            "Error joining computer '%1!ws!' to '%2!ws!': %3%%n",
            wczComputerName, lpwArgv[2], errmsg);
    }

    return 0;
}

// This is enough startup code for this program if compiled to use the DLL CRT.
#if !defined(_DEBUG) && !defined(DEBUG) && _MSC_VER < 1900
EXTERN_C int
wmainCRTStartup()
{
    int argc = 0;
    LPWSTR *argv = CommandLineToArgvW(GetCommandLine(), &argc);
    if (argv == NULL)
    {
#ifndef _M_ARM
        MessageBoxA(NULL, "This program requires Windows NT.",
            "Incompatible Windows version", MB_ICONERROR);
#endif
        ExitProcess((UINT)-1);
    }

    exit(wmain(argc, argv));
}
#endif
