#ifndef UNICODE
#define UNICODE
#endif
#ifndef _UNICODE
#define _UNICODE
#endif
#ifndef _DLL
#define _DLL
#endif

#define WIN32_LEAN_AND_MEAN

#include <winstrct.h>
#include <shellapi.h>
#include <stdlib.h>

#pragma comment(lib, "ntdllp.lib")
#pragma comment(lib, "kernel32.lib")
#pragma comment(lib, "user32.lib")
#pragma comment(lib, "shell32.lib")

int
WINAPI
wWinMain(HINSTANCE hCurInstance, HINSTANCE hPrevInstance, LPWSTR lpCmdLine,
    int nCmdShow)
{
    int argc;
    LPWSTR *argv = CommandLineToArgvW(GetCommandLineW(), &argc);
    if (argv == NULL)
    {
        MessageBoxA(NULL,
            "This program requires Windows NT.",
            "msgboxW",
            MB_ICONSTOP);
        ExitProcess((DWORD)-1);
    }

    return MessageBox(NULL,
        argc > 1 ? argv[1] : L"",
        argc > 3 ? argv[3] : NULL,
        argc > 2 ? wcstoul(argv[2], NULL, 0) : 0);
}


// This is enough startup code for this program if compiled to use the DLL CRT.
#if !defined(_DEBUG) && !defined(DEBUG) && _MSC_VER < 1900
int
wWinMainCRTStartup()
{
    ExitProcess(wWinMain(NULL, NULL, NULL, 0));
}
#endif
